"
" Файл конфигурации VIM — indvdum.vim
" 22.08.2010 17:38:26
"
" indvdum
"

" menu
set wildmenu
set wcm=<Tab>
menu Encoding.utf-8 :e ++enc=utf8<cr>
menu Encoding.cp1251 :e ++enc=cp1251<cr>
menu Encoding.koi8-r :e ++enc=koi8-r<cr>
menu Encoding.cp866 :e ++enc=cp866<cr>
menu Encoding.utf-16le :set enc=utf-8<cr>:e ++enc=utf-16le<cr>
menu Insert.date_time :start<cr><C-R>=strftime("%c")<CR>

set fileencodings=utf-8,cp1251,koi8-r,cp866,utf-16le
"set encoding=utf-8
set autoindent
set shiftwidth=4
set tabstop=4
set softtabstop=4
set smarttab
set is
set ic
set textwidth=0
set winminheight=0
set noequalalways
set nowrap
set winheight=9999
set nu
set iskeyword=@,48-57,_,192-255
set langmap=йq,цw,уe,кr,еt,нy,гu,шi,щo,зp,х[,ъ],фa,ыs,вd,аf,пg,рh,оj,лk,дl,ж\\;,э',яz,чx,сc,мv,иb,тn,ьm,б\\,,ю.,ё`,ЙQ,ЦW,УE,КR,ЕT,НY,ГU,ШI,ЩO,ЗP,Х{,Ъ},ФA,ЫS,ВD,АF,ПG,РH,ОJ,ЛK,ДL,Ж:,Э\\",ЯZ,ЧX,СC,МV,ИB,ТN,ЬM,Б<,Ю>,Ё~
sy on
if has("win32")
    set columns=120
    set lines=30
	set guifont=courier_new:h10:cRUSSIAN
endif
if has("gui_running") && !has("win32")
    set columns=120
    set lines=30
endif
set clipboard=unnamed
set visualbell
set laststatus=2
set statusline=%<%f%h%m%r%=format=%{&fileformat}\ file=%{&fileencoding}\ enc=%{&encoding}\ %b\ 0x%B\ %l,%c%V\ %P
set nobackup
set noswapfile
set undolevels=65536
if version >= 703
    set undofile
	set undodir=$VIMRUNTIME/../undofiles/
    set norelativenumber
    set colorcolumn=80
endif

"НАСТРОЙКИ ПОИСКА
set ignorecase " ics - поиск без учёта регистра символов
set smartcase " - если искомое выражения содержит символы в верхнем регистре - ищет с учётом регистра, иначе -  без учёта
set hls " подсветка результатов поиска
set incsearch " поиск фрагмента по мере его набора

"ВКЛЮЧЕНИЕ АВТОДОПЛНЕНИЯ ВВОДА (omnifunct)
autocmd FileType python set omnifunc=pythoncomplete#Complete
autocmd FileType tt2html set omnifunc=htmlcomplete#CompleteTags
autocmd FileType javascript set omnifunc=javascriptcomplete#CompleteJS
autocmd FileType html set omnifunc=htmlcomplete#CompleteTags
autocmd FileType css set omnifunc=csscomplete#CompleteCSS
autocmd FileType xml set omnifunc=xmlcomplete#CompleteTags
autocmd FileType php set omnifunc=phpcomplete#CompletePHP
autocmd FileType c set omnifunc=ccomplete#Complete

"" Переключение табов (вкладок)
map <S-tab> :tabprevious<cr>
nmap <S-tab> :tabprevious<cr>
imap <S-tab> <ESC>:tabprevious<cr>i
map <C-tab> :tabnext<cr>
nmap <C-tab> :tabnext<cr>
imap <C-tab> <ESC>:tabnext<cr>i
nmap <C-t> :tabnew<cr>
imap <C-t> <ESC>:tabnew<cr>
"nmap <C-w> :tabclose<cr>
"imap <C-w> <ESC>:tabclose<cr>

set go+=b
set lbr " переносить целые слова
set mouse= " выключает поддержку мыши при работе в терминале (без GUI)
set t_Co=256 " использовать больше цветов в терминале
filetype plugin indent on " определять подсветку на основе кода файла
"" Автоматически перечитывать конфигурацию VIM после сохранения
autocmd! bufwritepost $MYVIMRC source $MYVIMRC

if has("gui_running")
	colo desert
else
	colo ron
endif

set cursorline
set cursorcolumn
hi CursorLine ctermbg=235
hi CursorColumn ctermbg=235
hi Search ctermbg=DarkBlue ctermfg=LightGrey


" Теперь нет необходимости передвигать курсор к краю экрана, чтобы подняться в режиме редактирования
set scrolljump=1
" Теперь нет необходимости передвигать курсор к краю экрана, чтобы опуститься в режиме редактирования
set scrolloff=5
" Скрыть панель в gui версии ибо она не нужна
set guioptions-=T
" Включаем "умные" отступы ( например, автоотступ после {)
set smartindent


" Пробел в нормальном режиме перелистывает страницы
nmap <Space> <C-D><C-D>
nmap <S-Space> <C-U><C-U>

nmap <PageUp> <C-U><C-U>
imap <PageUp> <C-O><C-U><C-O><C-U>
nmap <PageDown> <C-D><C-D>
imap <PageDown> <C-O><C-D><C-O><C-D>

" < & > - делаем отступы для блоков
vmap < <gv
vmap > >gv

" не перепрыгивать через длинные строки при включенном переносе строк
nnoremap j gj
nnoremap k gk
vnoremap j gj
vnoremap k gk
nnoremap <DOWN> gj
nnoremap <UP> gk
vnoremap <DOWN> gj
vnoremap <UP> gk
inoremap <DOWN> <C-O>gj
inoremap <UP> <C-O>gk

" Ctrl-пробел для автодополнения
inoremap <C-space> <C-x><C-o>

map <F7> <Esc>:set wrap!<cr>:set wrap?<cr>
imap <F7> <Esc>:set wrap!<cr>:set wrap?<cr>
map <F8> <Esc>:emenu <TAB>
map <F12> <Esc>:tabnew $vimruntime/indvdum.vim<cr>
